package ru.dbotthepony.mc.otm.client.render

import net.minecraft.resources.ResourceLocation

class SubSkinElement(
	val parent: AbstractSkinElement,
	val xOffset: Float = 0f,
	val yOffset: Float = 0f,
	val subWidth: Float = parent.width,
	val subHeight: Float = parent.height,
) : AbstractSkinElement() {
	override val width: Float
		get() = subWidth
	override val height: Float
		get() = subHeight

	override val u0: Float
		get() = parent.u0 + (xOffset / parent.width) * (parent.u1 - parent.u0)
	override val v0: Float
		get() = parent.v0 + (yOffset / parent.height) * (parent.v1 - parent.v0)

	override val u1: Float
		get() = parent.u1 + ((xOffset + subWidth) / parent.width) * (parent.u1 - parent.u0)
	override val v1: Float
		get() = parent.v1 + ((yOffset + subHeight) / parent.height) * (parent.v1 - parent.v0)

	override val texture: ResourceLocation
		get() = parent.texture

	override val type: SkinElementType
		get() = SkinElementType.SUBELEMENT
}

fun AbstractSkinElement.subElement(
	x: Float = 0f,
	y: Float = 0f,
	width: Float = this.width,
	height: Float = this.height,
) = SubSkinElement(this, x, y, width, height)
